Redmine - Defect #28874

MailHandler does not log exceptions caught
2018-05-24 17:32 - Olivier Houdas

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email receiving Estimated time: 0.00 hour
Target version:

Resolution: Duplicate Affected version: 3.45
Description

Issue:

If a locally unhandled exception is raised when receiving a mail, the error is not logged.

How to repro:

1. Add the line

raise "An error occurred"

as the first line of the receive method

2. Run the rake task

rake redmine:email:receive_imap RAILS_ENV="production" host=imap.gmail.com port=993 move_on_succes
s=Success move_on_failure=Failure username=***** pgggword=*****

on a mailbox which has at least one unread mail in the mailbox

3. Check the redmine log
Result:

D, [2018-05-24T17:25:53.647960 #16786] DEBUG -- :
D, [2018-05-24T17:25:53.648109 #16786] DEBUG -- :

Expected result:

D, [2018-05-24T17:25:53.647960 #16786] DEBUG -- :
E, [2018-05-24T17:25:53.648076 #16786] ERROR -- :
has occured

D, [2018-05-24T17:25:53.648109 #16786] DEBUG -- :

Receiving message 21674
Message 21674 can not be processed

Receiving message 21674

MailHandler: an unexpected error occurred when receiving email: An error

Message 21674 can not be processed

Suggested fix: define logger as self.logger instead as just logger in the MailHandler class

Related issues:

Is duplicate of Redmine - Defect #30457: MailHandler.safe_receive does not ou... Closed

History

#1 - 2018-09-15 07:16 - Go MAEDA

- Target version set to Candidate for next minor release

#2 - 2018-10-02 04:31 - Yuichi HARADA

In my environment, it works normally.
With Gmail IMAP enabled, we did the following steps.

1. Insert raise "An error occurred" in source:trunk/app/models/mail_handler.rb#L 28.

2. Run the rake task.(rake redmine:email:receive_imap RAILS_ENV=development)

3. Check the log/development.log

Receiving message 16

MailHandler: an unexpected error occurred when receiving email: An error occurred

Message 16 can not be processed
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/mail_handler.rb#L28

#3 - 2018-10-02 05:05 - Go MAEDA
- Status changed from New to Needs feedback

- Target version deleted (Candidate for next minor release)

#4 - 2019-02-09 17:04 - Go MAEDA
- Status changed from Needs feedback to Closed

- Resolution set to Duplicate

| confirmed this issue and posted a patch. Please see #30457 for details. Thank you for reporting this issue.

#5 - 2019-02-09 17:05 - Go MAEDA

- Is duplicate of Defect #30457: MailHandler.safe_receive does not output any error log added
#6 - 2019-02-11 15:38 - Olivier Houdas

Thanks a million for fixing that issue! I'm really sorry | didn't have any time to work on Redmine in the last 6 months, but we're still using it in the
company.
